(* ICFP Programming Contest 2001
 * Copyright (C) 2001 Jean-Christophe Filliatre *)

open Sml_ng
open Output

(*s Randomly generated documents. *)

let length = int_of_string Sys.argv.(1)
let freq = int_of_string Sys.argv.(2)
let _ = Random.self_init ()

let random_char () = 
  let n = Random.int 10 in
  if n == 0 then print_char ' '
  else if n == 1 then print_char '\n'
  else print_char (Char.chr (97 + Random.int 26))

let rec random_n_chars n =
  if n > 0 then begin random_char (); random_n_chars (pred n) end

let random_tag () = match Random.int 25 with
  | 0 -> B
  | 1 -> EM
  | 2 -> I
  | 3 -> PL
  | 4 -> S
  | 5 -> TT
  | 6 -> U
  | 7 -> Color Red
  | 8 -> Color Green
  | 9 -> Color Blue
  | 10 -> Color Cyan
  | 11 -> Color Magenta
  | 12 -> Color Yellow
  | 13 -> Color Black
  | 14 -> Color White
  | n -> Size (n - 15)

let tag_size = function EM | PL | TT -> 9 | _ -> 7

let rec loop n =
  if n > 0 then begin
    if n >= 9 && Random.int freq == 0 then begin
      let t = random_tag () in
      let n' = n - tag_size t in
      open_tag t;
      let n'' = Random.int (succ n') in
      loop n'';
      close_tag t;
      loop (n' - n'')
    end else begin
      random_char ();
      loop (pred n)
    end
  end

let _ = loop length
